## aspectc++ 2.3+git20230726

=== Ag++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************


# PUMA root
PUMA    ?= ../Puma

# default target
TARGET  ?= linux-release

#AspectC++ source directory
AC_SRC_DIR := ../AspectC++

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

PLATFORM := $(shell echo $(_TARGET) | cut -d _ -f1)

# determine which Puma library to use: libMiniPuma is preferred
PUMA_LIBS := $(notdir $(wildcard $(PUMA)/lib/$(TARGET)/lib*Puma.a))
ifneq ($(filter libMiniPuma.a, $(PUMA_LIBS)),)
	PUMA_LIB := MiniPuma
else
	PUMA_LIB := Puma
endif

#CXX  := /usr/bin/g++-3.3
#CXX := ag++  -p. -p../aspects --Xcompiler
#CXX := ag++ -v3 -p. --Xcompiler

# compiler settings
ifeq ($(_TARGET),win32)
        CXXFLAGS += -I $(PUMA)/src/win32/regex
	EXT :=.exe
	RES := mingw32-windres
endif

CXXFLAGS += $(CPPFLAGS) -I$(PUMA)/extern -I$(PUMA)/include
ifneq ($(PLATFORM),macos)
	ifeq ($(SHARED),)
		LDFLAGS += -static
	endif

LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)

ifneq ($(SHARED),)
LDFLAGS += -Wl,-Bdynamic
endif

else
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)
endif

ifneq ($(PROFILING),)
	LDFLAGS += -lc_p -lm_p 
	CXXFLAGS += -pg
endif

# ******************************
# *       S O U R C E S        *
# ******************************

BINBASE := bin
BINDIR := $(BINBASE)/$(TARGET)
PROG := $(BINDIR)/ag++$(EXT)

CCSOURCES := $(wildcard *.cc) 

OBJECTBASE := ObjFiles
OBJECTDIR := $(OBJECTBASE)/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:%.cc=%.o))

DEPBASE := DepFiles
DEPDIR := $(DEPBASE)/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:%.cc=%.d))

ifeq ($(_TARGET),win32)
RCFILES := win-ag++.rc
OBJECTS += $(addprefix $(OBJECTDIR)/,$(RCFILES:%.rc=%.o))
DEPS += $(addprefix $(DEPDIR)/,$(RCFILES:%.rc=%.d))
endif


DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)



# ******************************
# *     T A R G E T S          *
# ******************************

all: showtarget $(AC_SRC_DIR)/$(PROG)

strip: $(AC_SRC_DIR)/$(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making Ag++ for TARGET=$(TARGET)"
	@echo "  AC++     = $(ACXX) $(ACXXFLAGS) <objects> "
	@echo "  Compiler = $(CXX) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"

help: showtarget
	@echo 
	@echo 
	@echo "Make:" 
	@echo "  help:          show this help"
	@echo "  all (default): compile, link and copy"
	@echo "  copy:          copy executable into AspectC++ bin folder"
	@echo "  test :         run tests"
	@echo "  test_<XX>:     run test number <XX>"
	@echo "  clean:         remove intermediate files of current TARGET"
	@echo "  distclean:     clean all generated files and directories"
	@echo "---"

clean: 
	@echo -n "CLEAN    "
	rm -rf $(PROG) core core.*  $(DIRS)

distclean:
	rm -rf $(DEPBASE) $(OBJECTBASE) $(BINBASE)
 

test:	all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests;./run_tests.sh

test_%: all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests; ./run_tests.sh $@


.PHONY: all clean distclean showtarget

# ******************************
# *       R U L E S            *
# ******************************

$(PROG): $(OBJECTS)
	@echo "LD        $@"
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $^ $(LDFLAGS)

$(AC_SRC_DIR)/$(PROG): $(PROG)
	@echo "COPY      $< to $@"
	@mkdir -p $(AC_SRC_DIR)/bin/$(TARGET)
	@cp $< $@

$(OBJECTDIR)/%.o : %.cc
	@echo "DEP       $(DEPDIR)/$(<:%.cc=%.d)."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DEPDIR)/$(<:%.cc=%.d) -MF $(DEPDIR)/$(<:%.cc=%.d) $< 
	@echo "CC        $@"
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CXXFLAGS) -c -o $@ $<

ifeq ($(_TARGET),win32)
$(OBJECTDIR)/%.o : %.rc
	@echo "DEP       $@."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DEPDIR)/$(<:%.cc=%.d) -MF $(DEPDIR)/$(<:%.cc=%.d) -xc++ $< 
	@echo "RES       $@"
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CXXFLAGS)) $< $@
endif

ifeq (,$(findstring clean,$(MAKECMDGOALS)))
ifeq (,$(findstring help,$(MAKECMDGOALS)))
-include $(DEPS)
endif
endif

.SUFFIXES: .cc .o .h .rc .mk $(SUFFIXES)

=== AspectC++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# AspectC++ supports alternative frontends: Puma or Clang
# It can be configured the 'make FRONTEND=...'. Default is Clang.
export FRONTEND ?= Clang

# PUMA root
PUMA    ?= ../Puma

# LLVM config command
LLVMCONF ?= llvm-config

# libxml2 config command
XML2CONF ?= xml2-config

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

PLATFORM := $(shell echo $(_TARGET) | cut -d _ -f1)
ARCH := $(shell echo $(_TARGET) | cut -d _ -f2-)

# check whether we compile for Windows: TARGET-Variable starts with 'win'
ifneq ($(filter win%,$(TARGET)),)
	WIN := yes
	EXT := .exe
endif

# libxml2 settings
LIBXML2_INC := `$(XML2CONF) --cflags` 
LIBXML2_LIB := `$(XML2CONF) --libs` 

# Check Clang version and define all necessary symbols (LLVM_*)
ifneq ($(MAKECMDGOALS),clean)
  ifeq ($(FRONTEND),Clang)
    include config/clang.mk
  endif
endif

# linker settings
ifneq ($(PLATFORM),macos)
ifeq ($(SHARED),)
  LDFLAGS += -static
endif
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma 
ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma 
ifneq ($(SHARED),)
	LDFLAGS += #-Wl,-Bdynamic
endif
endif
else
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma
endif
endif

LDFLAGS += $(LIBXML2_LIB)
ifneq ($(FRONTEND),Puma)
ifneq ($(PLATFORM),macos)
  LDFLAGS += -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
  # On the ARMEL platform we also need -latomic. This is a workaround for a gcc bug.
  LDFLAGS += -Wl,--as-needed -latomic -Wl,--no-as-needed
  # ... until here
#  LDFLAGS += `$(LLVMCONF) --libs`
  LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
else
# Mac OS X is special, we patch the clang libraries below.
  LDFLAGS += libclangSema.o -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
endif
LDFLAGS += `$(LLVMCONF) --ldflags`
# - Additional libraries ("--libs") needed
# - Starting with 4.0 "--system-libs" returns nothing if the debian clang package is used. "--link-static" forces
#   "--system-libs" to return the system libs in all cases
LDFLAGS += $(shell $(LLVMCONF) --libs --system-libs --link-static)
# workaround for strange MacOS config from clang                                                                                    
ifeq ($(PLATFORM),macos)
LDFLAGS := $(filter-out -llibxml2.tbd, $(LDFLAGS))
endif
endif

# compiler settings
ifeq ($(WIN),yes)
	RES := windres
	RCFILES := win-ac++.rc
endif

CPPFLAGS += -I$(PUMA)/extern -I$(PUMA)/include $(LIBXML2_INC)
ifeq ($(FRONTEND),Puma)
  CPPFLAGS += -DFRONTEND_PUMA
else
  FILTEROUT :=
ifeq ($(RELEASE),debug)
  # filter-out "-DNDEBUG" added by LLVMCONF, if LLVM is in built in release-mode
  FILTEROUT := -DNDEBUG
endif
  LLVM_CPPFLAGS := $(shell $(LLVMCONF) --cppflags)
  ifeq ($(WIN),yes)
    # llvm-config on Windows generates path name with '\' that mingw g++ can't handle properly
    LLVM_CPPFLAGS := $(subst \,/,$(LLVM_CPPFLAGS))
  endif
  CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
  CPPFLAGS += -DFRONTEND_CLANG
  CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header
  CXXFLAGS += -std=gnu++14 # Clang >= 11 uses C++14 features; "c++14" does not work -> WIN32 not defined on Windows!
endif

# profiling
ifneq ($(GPROF),)
	LDFLAGS := $(LDFLAGS) -lc_p -lm_p 
	CXXFLAGS += -pg
endif

ifneq ($(PROFILING),)
	CPPFLAGS += -DPROFILING
endif

# use libacmodel
LDFLAGS  += -LACModel/lib/$(TARGET) -lacmodel 


# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)

#programm to compile
PROG := $(BINDIR)/ac++$(EXT)

# sources; front-end specific files for the wrong frontend are filtered out
CCSOURCES := $(wildcard *.cc)
ifeq ($(FRONTEND),Puma)
CCSOURCES := $(filter-out Clang%.cc, $(CCSOURCES))
else
CCSOURCES := $(filter-out Puma%.cc, $(CCSOURCES))
endif

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o) $(RCFILES:.rc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

CONFIGDIR := config

DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)

# ******************************
# *  E X A M P L E  / T E S T  *
# ******************************

# tool selection
export AC := $(shell pwd)/$(PROG)
export AG := $(shell pwd)/$(BINDIR)/ag++$(EXT)

MAKE ?= make

# ac++ settings for tests
ACFLAGS := -k -v 9

ACEXAMPLES = coverage helloworld modules profiling singleton threads


.PHONY: $(ACEXAMPLES) 


# ******************************
# *      T A R G E T S         *
# ******************************

all: libacmodel showtarget $(PROG)
#.NOTPARALLEL: all

strip: $(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"


clean:  testclean exampleclean
	@echo Making it clean.
	@$(MAKE) -C ACModel clean
	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)

cleanall:	doxygen-clean clean

test: $(PROG)$(EXT) testall

example: $(PROG)$(EXT) $(addsuffix .example_make, $(ACEXAMPLES))

examplerun: example $(addsuffix .example_run, $(ACEXAMPLES))

exampleclean:
	@rm -rf examples/*-out
	@rm -rf examples/*.acp

doxygen:
	@echo "Making AspectC++ documentation with doxygen"
	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"

doxygen-clean:
	@rm -rf doc/doxygen

.PHONY: all test clean cleanall example examplerun exampleclean \
        showtarget doxygen doxygen-clean libacmodel

# ******************************
# *       R U L E S            *
# ******************************

$(DIRS) :
	@mkdir -p $@

libacmodel :
	@$(MAKE) -C ACModel

$(PROG): $(OBJECTS) | libacmodel
# For clang on macOS we create relinked objects with the patched symbols.
ifneq ($(FRONTEND),Puma)
ifeq ($(PLATFORM),macos)
	@echo "Creating patched clang libraries ..."
	@$(LD) -arch $(ARCH) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
          $(foreach SYM, $(LLVM_SYMBOLS_SEMA), -alias $(SYM) ___real$(SYM) -unexported_symbol $(SYM))
endif
endif
	@echo "Linking $@."
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)


$(OBJECTDIR)/%.o : %.cc
	@echo Making dependency file $(DEPDIR)/$(<:%.cc=%.d).
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MP -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $(DEPDIR)/$(<:%.cc=%.d) $< > $(DEPDIR)/$(<:%.cc=%.d)
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

# -Wold-style-cast to find classic C casts "a = (A*)b;"

ifeq ($(WIN),yes)
$(OBJECTDIR)/%.o : %.rc
	@echo Compiling Windows resource file
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CPPFLAGS)) $< $@

endif

test%: 
	$(MAKE) -C tests -s  $*

%.example_make: %
	cd examples/$< ; \
	$(AC) $(ACFLAGS) -I. -p . -d ../$<-out \
	-r ../$<.acp ; \
	cp Makefile ../$<-out/Makefile; \
	cd ../$<-out; g++ -o $< *.cc -lpthread

%.example_run:	%.example_make
	@echo ""
	@echo ---- Running $* ----
	@cd examples/$*-out; `find . -type f -perm -700`

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== AspectC++/config/Makefile ===
#
# makefile for generating a config file for the installed Clang version
#

# PUMA root
PUMA    ?= ../../Puma

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

PLATFORM := $(shell echo $(_TARGET) | cut -d _ -f1)

# ******************************
# *       S E T T I N G S      *
# ******************************

# check whether llvm-config is available
ifeq ($(shell which $(LLVMCONF)),)
  $(error LLVMCONF ($(LLVMCONF)) is not found)
endif

LLVM_VERSION := $(shell $(LLVMCONF) --version)

LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
ifeq ($(PLATFORM),win) # handle '\' in path name
  LLVM_LIBDIR := $(subst \,/,$(LLVM_LIBDIR))
endif
LLVM_LIBS :=  $(LLVM_LIBDIR)/libclang*.a
# These functions need to be wrapped:
#   Parameters are omitted to be more version independent
LLVM_KEYS := _ZN5clang4Sema19canSkipFunctionBody \
             _ZN5clang4Sema21ProcessStmtAttributes

ifeq ($(PLATFORM),macos) # on macOS the symbols have an additional '_'
  LLVM_KEYS := $(patsubst %, _%, $(LLVM_KEYS))
endif

# command to generate LLVM_SYMBOLS (a recursive variable!)
LLVM_SYMBOLS_GEN = $(foreach LLVM_LIB, $(LLVM_LIBS), $(foreach LLVM_KEY, $(LLVM_KEYS), $(filter _%, $(shell nm --defined-only $(LLVM_LIB) | grep "T $(LLVM_KEY)"))))

ifeq ($(PLATFORM),macos) # on macOS the symbols have an additional '_'
  LLVM_SYMBOLS_GEN := $(patsubst _%, %, $(LLVM_SYMBOLS_GEN))
endif

# ******************************
# *       R U L E S            *
# ******************************

clang: clang-$(LLVM_VERSION).mk

# find the exact symbols using the keys in the clang libraries
clang-$(LLVM_VERSION).mk:
	@echo Generating config file for Clang $(LLVM_VERSION)
	@echo LLVM_SYMBOLS := $(LLVM_SYMBOLS_GEN) > $@

=== AspectC++/doc/Makefile ===
LYXFILES := ac-compilerman.lyx ac-languageref.lyx
DIRS := CompilerManual LanguageReference
PDFFILES := $(patsubst %.lyx,gen/%.pdf,$(LYXFILES))
XHTMLFILES := $(patsubst %.lyx,gen/%.xhtml,$(LYXFILES))

VPATH = CompilerManual:LanguageReference

all: $(PDFFILES) $(XHTMLFILES)

gen/%.pdf: %.lyx
	@echo Exporting $@
	@lyx -E pdf2 $@ $< > gen/logpdf.txt

gen/%.xhtml: %.lyx
	@echo Exporting $@
	@lyx -E xhtml $@ $< > gen/logxhtml.txt
	@echo Transforming export file
	@mv $@ $@.trans
	@xsltproc gen/fixhtml.xsl $@.trans > $@
	@rm $@.trans
	@echo Renaming SVGs
	@for f in gen/*_doc_*.svg; do mv $$f gen/$${f#*_doc_}; done

clean:
	@rm -rf $(PDFFILES) $(XHTMLFILES) gen/log*.txt gen/*~ $(patsubst %, gen/%_*.svg, $(DIRS))

=== AspectC++/tests/Makefile ===
ifeq ($(REGRESSIONTEST),1)
MAKELEVEL := 1
endif

ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the AspectC++ source tree instead)
endif

SHELL=/bin/bash
DIFF=diff --strip-trailing-cr

ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
          Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
          ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
          MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
	  Order NonInlineIntros JPType PragmaOnce Bug207 \
	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
          VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
	  CFlowCycle Bug368 Bug179 RightlessCalls Bug477 \
	  IntroInBase Bug267 Bug268 Bug271 MatchVirtual \
	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
          MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
	  MemberPointCut MatchScopeWithin \
	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
          VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770 Bug772 \
          Bug781 Bug784 BugUsingAttribute

ifeq ($(FRONTEND),Clang)
ACTESTS += DataFlowAnalysis
ACTESTS += CallBuiltinOperator MemberPointCut2
ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
           SimpleRefAdvice SimpleAliasAccessMember SimpleGetSetFuncPtr \
           ArrayAccessAdvice MatchScope GetBaseDerived \
           Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
           Bug567 Bug568 Bug548 Bug589 Bug594 Bug598 CallRef \
           EntityInfo VolatileResult Bug792 BugAttribInConstexpr StdCxx17
ACTESTS += Attribute_basic Attribute_inMacro Attribute_removeAttrs
		   #Attribute_pointcuts Attribute_params Attribute_paramEvaluation \
		   #Attribute_paramsIntrospection Attribute_stringParam
                   #TypePrinting_FunctionPointers <-- waiting for clang improvement
ifneq ($(shell uname -s),Darwin)
ACTESTS += Float128Basic
endif

endif

# disabled: UnsizedArray
# to be removed: NonInlineIntroInclude
# (uses deprecated introduction syntax massively)

ACMSGTESTS := RepoInvalid RepoVersion Bug570

ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))

ACRUN   := $(filter-out $(ACNORUN), $(ACTESTS))

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE :=  error.txt

# ***** The following is only used for the Akut testsystem (REGRESSIONTEST == 1) *****
# ====================================================================================
ifeq ($(REGRESSIONTEST),1)

define do_test_start
    @COUNT=0;PASS=0;FAIL=0;
endef

define do_test_weave
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(1)/feature.out; \
	exec 2> $(1)/feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $(1)/feature.err $(1)/feature.out; \
	rm $(1)/feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_run
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $(1) diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_end
	echo -n "---EXECUTIVE SUMMARY: " ;\
	if [ $$FAIL -eq $$COUNT ]; then\
		echo FAIL \(all tests failed\) ;\
	elif [ $$FAIL -gt 0 ]; then \
		echo PARTLY \($$(( $$PASS * 100 / $$COUNT ))% tests passed as expected\); \
	else \
		echo PASS \(all tests passed\) ;\
	fi ;\
	echo ---START SUMMARY; \
	echo $$COUNT tests in this testcase; \
	echo $$PASS tests passed as expected; \
	echo $$FAIL tests did not pass as expected; \
	echo $$FAIL expected to pass but failed; \
	echo 0 expected to fail but passed; \
	echo ---END SUMMARY
endef

regression_test:
	$(call do_test_start) \
	$(foreach T, $(ACRUN), $(call do_test_run, $(T))) \
	$(foreach T, $(ACNORUN), $(call do_test_weave, $(T))) \
	$(call do_test_end)

endif

# ================================================================================
# ***** The above is only used for the Akut testsystem (REGRESSIONTEST == 1) *****


all: $(addsuffix .make, $(ACRUN)) $(addsuffix .weave, $(ACNORUN))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
		rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE); \
		exit 1; \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 	rm -f $(STDOUT_FILE) $(STDERR_FILE); \
	 fi;\

ref:  $(addsuffix .ref, $(ACTESTS))

refclean:
	rm */feature.ref

run: $(addsuffix .run, $(ACRUN))

clean: $(addsuffix .clean, $(ACTESTS))


%.weave: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $</feature.out; \
	exec 2> $</feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $</feature.err $</feature.out; \
	rm $</feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;


%.make: %
	@exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $< diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;




%.ref: %
	$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.run:	%
	@echo Making and running test '$<'
	cd $< && $(MAKE) run

%.clean: %
	cd $< && $(MAKE) clean

.PHONY: all clean run ref

=== AspectC++/tests/ArrayAccessAdvice/Makefile ===
ACFLAGS += --builtin_operators --data_joinpoints
CXXFLAGS += -std=gnu++11
AC_PATTERN_REPLACEMENTS := | sed -e "s/::__1::/::/g"
include ../Makefile.generic

=== AspectC++/tests/Attribute_removeAttrs/Makefile ===
ACFLAGS ?= --data_joinpoints --builtin_operators
CXXFLAGS ?= -std=c++11 -Werror
include ../Makefile.generic

=== AspectC++/tests/Bug589/Makefile ===
ACFLAGS ?= --data_joinpoints
include ../Makefile.generic

=== AspectC++/tests/Bug598/Makefile ===
ACFLAGS ?= --builtin_operators --data_joinpoints
# until Clang 12 the signature was printed as "char const arr[2]" instead of "const char arr[2]"
# the test should work for all versions -> replace in old output
AC_PATTERN_REPLACEMENTS := | sed -e "s/char const arr/const char arr/"
include ../Makefile.generic

=== AspectC++/tests/ForcedInclude/Makefile ===
ACFLAGS ?= --include config.h
include ../Makefile.generic

=== AspectC++/tests/STLString/Makefile ===
#AC_PATTERN_REPLACEMENTS := | sed -e "s/std::.*basic_string<char.*>/<<<replaced>>>/" | sed -e "s/void /VOID  /"
AC_PATTERN_REPLACEMENTS := | sed -e "s/std::.*basic_string<char.*>/<<<replaced>>>/"
include ../Makefile.generic

=== Puma/tests/bug258/Makefile ===
CCPARSEROPTFLAGS=--real-instances
include ../Makefile.generic

=== debian/changelog ===
aspectc++ (1:2.3+git20230726-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:42:33 +0200

aspectc++ (1:2.3+git20230726-1) unstable; urgency=medium

  * New upstream release, more fixes for gcc-13, Closes: #1041040

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 25 Jul 2023 06:26:07 -0400

aspectc++ (1:2.3+git20230630-1) unstable; urgency=medium

  * Fix compilation against gcc+13, Closes: #1037581

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 30 Jun 2023 07:13:11 -0400

aspectc++ (1:2.3+git20221129-2) unstable; urgency=medium

  * debian/control: Build-Depend on libpolly-14-dev, Closes: #1028810

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 29 Jan 2023 14:54:50 -0500

=== debian/control ===
Source: aspectc++
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 10), pkg-config, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-14-dev, libclang-14-dev, libpolly-14-dev
Build-Depends-Indep: doxygen, graphviz, gsfonts
Standards-Version: 4.4.1
Homepage: http://www.aspectc.org
Vcs-Git: https://salsa.debian.org/debian/aspectc
Vcs-Browser: https://salsa.debian.org/debian/aspectc

Package: aspectc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: aspect-oriented programming extension for C++
 AspectC++ supports Aspect-Oriented Programming with C++, by providing:
 .
  - an aspect language extension to C++.
  - an aspect weaver that does source-to-source translation.
 .
 AspectC++ provides for C++ similar features like its best known
 cousin, AspectJ, provides for Java.

Package: libpuma-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Suggests: libpuma-doc
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships a static copy of libPuma only.

Package: libpuma-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships doxygen generated documentation for Puma.

## aspectc++ 2.3+git20241211

=== AspectC++/Makefile ===
--- 
+++ 
@@ -8,6 +8,9 @@
 
 # PUMA root
 PUMA    ?= ../Puma
+
+# ACModel root
+ACMODEL ?= ACModel
 
 # LLVM config command
 LLVMCONF ?= llvm-config
@@ -70,6 +73,9 @@
 ifneq ($(FRONTEND),Puma)
 ifneq ($(PLATFORM),macos)
   LDFLAGS += -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
+  ifeq ($(filter-out 18.1.3 18.1.8, $(shell $(LLVMCONF) --version)),)
+	LDFLAGS += -lclangAPINotes -lclangSupport -lclangASTMatchers -lclangBasic # extra libs for clang-18
+  endif
   # On the ARMEL platform we also need -latomic. This is a workaround for a gcc bug.
   LDFLAGS += -Wl,--as-needed -latomic -Wl,--no-as-needed
   # ... until here
@@ -112,8 +118,10 @@
   endif
   CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
   CPPFLAGS += -DFRONTEND_CLANG
-  CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header
-  CXXFLAGS += -std=gnu++14 # Clang >= 11 uses C++14 features; "c++14" does not work -> WIN32 not defined on Windows!
+  CXXFLAGS += -fno-rtti -Wno-strict-aliasing -Wno-nonnull # hide annoying warnings in Clang headers
+  # Clang >= 11 uses C++14 features; "c++14" does not work -> WIN32 not defined on Windows!
+  # clang >= 18 requires C++17
+  CXXFLAGS += -std=gnu++17 
 endif
 
 # profiling
@@ -127,8 +135,8 @@
 endif
 
 # use libacmodel
-LDFLAGS  += -LACModel/lib/$(TARGET) -lacmodel 
-
+LDFLAGS  += -L$(ACMODEL)/lib/$(TARGET) -lacmodel 
+ACMODELLIB := $(ACMODEL)/lib/$(TARGET)/libacmodel.a
 
 # ******************************
 # *       S O U R C E S        *
@@ -144,7 +152,9 @@
 ifeq ($(FRONTEND),Puma)
 CCSOURCES := $(filter-out Clang%.cc, $(CCSOURCES))
 else
+CLANG_PATCHED_SOURCES := $(filter Clang-$(LLVM_VERSION)-%.cc, $(CCSOURCES))
 CCSOURCES := $(filter-out Puma%.cc, $(CCSOURCES))
+CCSOURCES := $(filter-out Clang-%.cc, $(CCSOURCES)) $(CLANG_PATCHED_SOURCES)
 endif
 
 OBJECTDIR := ObjFiles/$(TARGET)
@@ -180,7 +190,11 @@
 # *      T A R G E T S         *
 # ******************************
 
-all: libacmodel showtarget $(PROG)
+all:
+	@$(MAKE) -C ACModel
+	@$(MAKE) showtarget
+	@$(MAKE) $(PROG)
+
 #.NOTPARALLEL: all
 
 strip: $(PROG)
@@ -195,8 +209,8 @@
 
 
 clean:  testclean exampleclean
+	@$(MAKE) -C ACModel clean
 	@echo Making it clean.
-	@$(MAKE) -C ACModel clean
 	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)
 
 cleanall:	doxygen-clean clean
@@ -218,8 +232,9 @@
 doxygen-clean:
 	@rm -rf doc/doxygen
 
-.PHONY: all test clean cleanall example examplerun exampleclean \
-        showtarget doxygen doxygen-clean libacmodel
+.PHONY: all strip showtarget \
+		test clean cleanall example examplerun exampleclean \
+        doxygen doxygen-clean
 
 # ******************************
 # *       R U L E S            *
@@ -228,10 +243,7 @@
 $(DIRS) :
 	@mkdir -p $@
 
-libacmodel :
-	@$(MAKE) -C ACModel
-
-$(PROG): $(OBJECTS) | libacmodel
+$(PROG): $(OBJECTS) $(ACMODELLIB)
 # For clang on macOS we create relinked objects with the patched symbols.
 ifneq ($(FRONTEND),Puma)
 ifeq ($(PLATFORM),macos)

=== AspectC++/ACModel/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# default target
TARGET  ?= linux-release
ifeq ($(filter %-release,$(TARGET)),)
RELEASE := debug
else
RELEASE := release
endif

# libxml2 settings
XML2CONF ?= xml2-config
LIBXML2_INC := `$(XML2CONF) --cflags` 

# compiler setting
ifeq ($(RELEASE),debug)
CFLAGS := -O0 -ggdb3 -fno-inline -fno-default-inline
else
CFLAGS   ?= -O2 -ggdb3
CPPFLAGS += -DNDEBUG
endif
CFLAGS   += -Wall -pipe
CXXFLAGS += $(CFLAGS) -std=gnu++11 # -fno-rtti -fno-exceptions

CPPFLAGS += $(LIBXML2_INC)

# ******************************
# *       S O U R C E S        *
# ******************************

# library file
LIBDIR := lib/$(TARGET)
LIB := $(LIBDIR)/libacmodel.a

CCSOURCES := $(wildcard *.cc) 

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

DIRS := $(OBJECTDIR) $(DEPDIR) $(LIBDIR)

# ******************************
# *      T A R G E T S         *
# ******************************

all:
	@$(MAKE) showtarget
	@$(MAKE) $(LIB)

showtarget:
	@echo "---"
	@echo Making ACModel library for TARGET=$(TARGET)
	@echo   Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)
	@echo "---"
  
clean:
	@echo Cleaning ACModel.
	@rm -rf core core.* *~ lib DepFiles ObjFiles

# ******************************
# *       R U L E S            *
# ******************************

$(LIB): $(OBJECTS) 
	@echo "Creating library $@."
	@mkdir -p $(LIBDIR)
	@$(AR) rcs $@  $(OBJECTS)

$(OBJECTDIR)/%.o : %.cc 
	@echo Making dependency file $@.
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MP -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $(DEPDIR)/$(<:%.cc=%.d) $< > $(DEPDIR)/$(<:%.cc=%.d)
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

.phony: all clean showtarget

=== AspectC++/tests/Attribute_basic/Makefile ===
ACFLAGS ?= --data_joinpoints --builtin_operators
CXXFLAGS ?= -std=c++11
include ../Makefile.generic

=== AspectC++/tests/BugAttribInConstexpr/Makefile ===
CXXFLAGS ?= -std=c++17
include ../Makefile.generic

=== AspectC++/tests/BugUsingAttribute/Makefile ===
CXXFLAGS ?= -std=c++11
include ../Makefile.generic

=== AspectC++/tests/ExecAdviceNewDelete/Makefile ===
AC_PATTERN_REPLACEMENTS := | sed -e "s/new(.*)/new(<<<replaced>>>)/" | sed -e "s/new\[\](.*)/new[](<<<replaced>>>)/"
include ../Makefile.generic

=== AspectC++/tests/TypePrinting_FunctionPointers/Makefile ===
ACFLAGS += --builtin_operators --data_joinpoints
include ../Makefile.generic

=== Puma/examples/cparser/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

PROG     := cparser

ROOT     ?= $(shell pwd)/../..
TARGET   ?= linux-release

INCDIR   := $(ROOT)/include
EXTDIR   := $(ROOT)/extern
LIBDIR   := $(ROOT)/lib/$(TARGET)
OBJDIR   := obj
DEPDIR   := dep

SOURCES  := $(wildcard *.cc) 
OBJECTS  := $(addprefix $(OBJDIR)/,$(SOURCES:.cc=.o))
DEPS     := $(addprefix $(DEPDIR)/,$(SOURCES:.cc=.d))

include $(ROOT)/vars.mk

CPPFLAGS := $(CPPFLAGS) -I$(INCDIR) -I$(EXTDIR)
#-L$(LIBDIR)

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo $(PROG)

showinfo:
	@echo 
	@echo "---"
	@echo "Compiling $(PROG) for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"
	@echo 

$(PROG): $(OBJECTS)
	@echo "Linking $@..."
	@export LD_LIBRARY_PATH=$(LIBDIR); \
	$(CXX) -o $@ $^ -L$(LIBDIR) $(CXXFLAGS) -Wl,-Bstatic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 
#	$(CXX) -o $@ $^ -L$(LIBDIR) $(CXXFLAGS) -Wl,-Bdynamic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 

clean:
	@echo "Making $(PROG) clean..."
	@rm -f $(PROG)
	@rm -rf $(DEPDIR) $(OBJDIR)

#-------------------------------------------------
# targets
#-------------------------------------------------

$(OBJDIR)/%.o : %.cc
	@echo "Compiling $(filter %.cc,$^)..."
	@mkdir -p $(OBJDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -g -o $@ $(filter %.cc,$^)

$(DEPDIR)/%.d : %.cc
	@echo "Generating dependencies for $(filter %.cc,$^)..."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM $(filter %.cc,$^) | \
	sed -e "s/$*\.o/$(OBJDIR)\/& $(DEPDIR)\/$*.d/g" > $@

.PHONY: clean

#-------------------------------------------------
# includes
#-------------------------------------------------

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== Puma/tools/prof/Makefile ===
all:

clean:

cleanall:

=== debian/changelog ===
aspectc++ (1:2.3+git20241211-1build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 May 2025 10:24:53 +0200

aspectc++ (1:2.3+git20241211-1) unstable; urgency=medium

  * New upstream version 2.3+git20241211
    - Includes r1697: fix for aarch64 problem for error while parsing math.h
  * debian/rules: allow weaving Puma to fail, Closes: #1070443

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 11 Dec 2024 05:15:38 -0500

aspectc++ (1:2.3+git20241206-1) unstable; urgency=medium

  * New upstream version 2.3+git20241206
    - Build against clang 18, closes: #1076205
    - Fixes build on arm64, closes: #1070443
  * debian/control:
    - Add build-depends on libzstd-dev
    - Replace pkg-config with pkgconf
    - Clarify package descriptions
    - Use canonical Git URI
    - Bump Standards version, no changes needed

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 06 Dec 2024 08:03:49 -0500
